/***************************************************************/
/*  COLOR Dialog                                               */
/***************************************************************/

#include <ientryfd.hpp>
#include <istattxt.hpp>
#include <icmdevt.hpp>
#include <istring.hpp>
#include <ispinnum.hpp>
#include <istattxt.hpp>
#include <ireslib.hpp>
#include <os2/os2.h>

#include "colordlg.hpp"
#include "mainwnd.h"


/***************************************************************/
/*  Dialog main body                                           */
/***************************************************************/

AClrDialog :: AClrDialog(char *msg,
                         IWindow * ownerWnd)
            : IFrameWindow(IResourceId(IDD_COLOR), ownerWnd)
{
 IColor  cCur(0,0,0);
 int     x1, y1, x2, y2;

// setText(msg);

 tfMsg = new IEntryField(IDDC_SHOW, this);  // test field
 stRed = new IStaticText(301, this);        // static text
 stGreen = new IStaticText(302, this);
 stBlue  = new IStaticText(303, this);

 IRectangle rectE(tfMsg->rect());
 IRectangle rectR(stRed->rect());
 IRectangle rectG(stGreen->rect());
 IRectangle rectB(stBlue->rect());

 x1 = rectR.right() + 10;
 y1 = rectR.bottom();
 x2 = rectE.left() - 10;
 y2 = y1 + 12;

 nsbRed = new INumericSpinButton(IDDC_SBR, this, this,
                                 IRectangle(x1, y1, x2, y2));

 x1 = rectG.right() + 10;
 y1 = rectG.bottom();
 y2 = y1 + 12;

 nsbGreen = new INumericSpinButton(IDDC_SBG, this, this,
                                   IRectangle(x1, y1, x2, y2));

 x1 = rectB.right() + 10;
 y1 = rectB.bottom();
 y2 = y1 + 12;

 nsbBlue  = new INumericSpinButton(IDDC_SBB, this, this,
                                   IRectangle(x1, y1, x2, y2));

 dlgOwner = ownerWnd;

 tfMsg->setBackgroundColor(ownerWnd->backgroundColor());
 tfMsg->setForegroundColor(ownerWnd->foregroundColor());
 tfMsg->setText(msg);
 cMode = msg[0];              //save first char of text as mode
 if (cMode == 'F')
    cCur = tfMsg->foregroundColor();
 else
    cCur = tfMsg->backgroundColor();
 ucRed   = cCur.redMix();
 ucGreen = cCur.greenMix();
 ucBlue  = cCur.blueMix();

 nsbRed->setRange(IRange(0,255));
 nsbRed->spinTo( (long) ucRed );
 nsbGreen->setRange(IRange(0,255));
 nsbGreen->spinTo( (long) ucGreen );
 nsbBlue->setRange(IRange(0,255));
 nsbBlue->spinTo( (long) ucBlue );

 ICommandHandler :: handleEventsFor(this);
}

AClrDialog :: ~AClrDialog()
{
}
/***************************************************************/
/*  Command Processor                                          */
/***************************************************************/

Boolean AClrDialog :: command(ICommandEvent& cmdevt)
{
  switch (cmdevt.commandId())
  {
   case IDDC_APPLY:
   {
    unsigned char ucRedTest, ucGreenTest, ucBlueTest;
    ucRedTest = nsbRed->value();
    ucGreenTest = nsbGreen->value();
    ucBlueTest  = nsbBlue->value();

    IColor cCur(ucRedTest, ucGreenTest, ucBlueTest);

    if (cMode == 'F')
      dlgOwner->setForegroundColor(cCur);
    else
      dlgOwner->setBackgroundColor(cCur);

    dismiss(IDDC_APPLY);
    return(true);
    break;
   }

   case IDDC_TEST:
   {
    unsigned char ucRedTest, ucGreenTest, ucBlueTest;
    ucRedTest = nsbRed->value();
    ucGreenTest = nsbGreen->value();
    ucBlueTest  = nsbBlue->value();

    IColor cCur(ucRedTest, ucGreenTest, ucBlueTest);

    if (cMode == 'F')
      tfMsg->setForegroundColor(cCur);
    else
      tfMsg->setBackgroundColor(cCur);

    return(true);
    break;
   }

   case IDDC_CANCEL:
   {
      dismiss(IDDC_CANCEL);
      return(true);
      break;

   }
  }
  return(false);
}
